import { DataTypePoint, DataTypePath, DataTypeGeometry, DataTypeLine, DataTypeSegment, DataTypePolygon, DataTypeBox, DataTypeCircle, _Int, _Point, _Numbers, _Strings, _Bit, _Bits, _Timestamp, _Geometry, _Path, _Boolean, _Uuid, DataTypeFrom } from '@typed-query-builder/builder';
declare module "@typed-query-builder/builder" {
    interface DataTypeInputRegistry {
        smallserial: 'SMALLSERIAL';
        serial: 'SERIAL';
        bigserial: 'BIGSERIAL';
    }
    interface DataTypeSmallSerialTypes {
        base: number;
    }
    interface DataTypeSerialTypes {
        base: number;
    }
    interface DataTypeBigSerialTypes {
        base: number;
    }
    interface DataTypePointTypes {
        srid: DataTypePoint & {
            srid: _Int;
        };
    }
    interface DataTypeLineTypes {
        srid: DataTypeLine & {
            srid: _Int;
        };
    }
    interface DataTypeSegmentTypes {
        srid: DataTypeSegment & {
            srid: _Int;
        };
    }
    interface DataTypePathTypes {
        srid: DataTypePath & {
            srid: _Int;
        };
    }
    interface DataTypePolygonTypes {
        srid: DataTypePolygon & {
            srid: _Int;
        };
    }
    interface DataTypeBoxTypes {
        srid: DataTypeBox & {
            srid: _Int;
        };
    }
    interface DataTypeCircleTypes {
        srid: DataTypeCircle & {
            srid: _Int;
        };
    }
    interface DataTypeGeometryTypes {
        srid: DataTypeGeometry & {
            srid: _Int;
        };
    }
    type _SmallSerial = DataTypeFrom<DataTypeSmallSerialTypes>;
    type _Serial = DataTypeFrom<DataTypeSerialTypes>;
    type _BigSerial = DataTypeFrom<DataTypeBigSerialTypes>;
    interface DataTypeTypes {
        SMALLSERIAL: _SmallSerial;
        SERIAL: _Serial;
        BIGSERIAL: _BigSerial;
    }
    interface Functions {
        minScale(x: _Numbers): _Numbers;
        scale(x: _Numbers): _Numbers;
        trimScale(x: _Numbers): _Numbers;
        widthBucket(operand: _Numbers, low: _Numbers, high: _Numbers, count: _Int): _Int;
        bitLength(text: _Strings): _Int;
        toHex(n: _Int): _Strings;
        octetLength(x: _Strings): _Int;
        getBit(x: _Bits, n: _Int): _Int;
        getByte(x: _Bits, n: _Int): _Int;
        setBit(x: _Bits, n: _Int, bit: _Int): _Bit;
        setByte(x: _Bits, n: _Int, byte: _Int): string;
        sha224(x: _Strings): _Strings;
        sha256(x: _Strings): _Strings;
        sha384(x: _Strings): _Strings;
        sha512(x: _Strings): _Strings;
        encode(x: _Strings, format: _Strings): _Strings;
        decode(x: _Strings, format: _Strings): _Strings;
        age(from: _Timestamp, to?: _Timestamp): _Strings;
        geomTranslate<T extends _Geometry>(a: T, by: _Point): T;
        geomPathConcat(a: _Path, b: _Path): _Path;
        geomScale<T extends _Geometry>(a: T, by: _Point): T;
        geomDivide<T extends _Geometry>(a: T, by: _Path): T;
        geomSame(a: _Path, b: _Path): _Boolean;
        uuid(): _Uuid;
    }
}
